Rolling = {}
Rolling["Page"] = {}
Rolling["Color"] = {"ffff00", "0099ff", "663300"}
Rolling["Class"] = {"none", "Plate", "Plate", "Chain", "Leather", "Cloth", "Plate", "Chain", "Cloth", "Leather", "Leather", "Leather"}
                          --Warrior, Pala,   Hunter,    Rouge,   Priest,  DeathKinght,Shaman,Mage,Warlock,Monk,   Druide,   DemonHunter
RollingCurrentPage = 0
RollingStart = false
RollingForItem = false
RollingFrameOpen = false

local _, _, pc = UnitClass("player")
PlayerClass = Rolling["Class"][pc]
PlayerRealm = GetRealmName()

RollingFrame = CreateFrame("Frame", "Rolling_Frame", UIParent, "BasicFrameTemplateWithInset")
RollingFrame:ClearAllPoints()
RollingFrame:SetSize(300,230)
RollingFrame:SetPoint("CENTER", UIParent, "CENTER")
RollingFrame:SetMovable(true)
RollingFrame:EnableMouse(true)
RollingFrame:SetUserPlaced(true)
RollingFrame:SetScript("OnMouseDown", RollingFrame.StartMoving)
RollingFrame:SetScript("OnMouseUp", function (self)
    RollingFrame:StopMovingOrSizing()
    RollingI.XPos = self:GetLeft()
    RollingI.YPos = self:GetBottom()
end)
RollingFrame:SetScript("OnHide", function()
    RollingFrameOpen = false
end)
RollingFrame:SetScript("OnShow", function()
    RollingFrameOpen = true
end)

RollingFrame.icon = {}
RollingFrame.icon.right = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.icon.right:SetPoint("Right", RollingFrame, "TOP", 140, -40)
RollingFrame.icon.right:SetSize(32, 32)
RollingFrame.icon.right.overlay = RollingFrame.icon.right:CreateTexture(nil, "OVERLAY")
RollingFrame.icon.right.overlay:SetPoint("Right", RollingFrame, "TOP", 140, -40)
RollingFrame.icon.right.overlay:SetSize(32, 32)
RollingFrame.icon.right.overlay:SetTexture("interface/addons/Rolling/img/Right.blp")
RollingFrame.icon.right:RegisterForClicks("AnyUp")
RollingFrame.icon.right:SetScript("OnEnter", function(self)
    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
    GameTooltip:ClearLines()
    if RollingCurrentPage+1 > table.getn(Rolling["Page"]) then
        GameTooltip:AddLine("Page: "..RollingCurrentPage.."/"..table.getn(Rolling["Page"]))
    else
        GameTooltip:AddLine("Page: "..RollingCurrentPage.."/"..table.getn(Rolling["Page"]).."\n"..Rolling["Page"][RollingCurrentPage+1]["Item"].."\nFrom: "..Rolling["Page"][RollingCurrentPage+1]["from"])
    end
    GameTooltip:Show()
end)
RollingFrame.icon.right:SetScript("OnLeave", function()
    GameTooltip:Hide()
end)
RollingFrame.icon.right:SetScript("OnMouseDown", function()
    if RollingCurrentPage < table.getn(Rolling["Page"]) then
        RollingCurrentPage = RollingCurrentPage + 1
        GameTooltip:ClearLines()
        if RollingCurrentPage+1 > table.getn(Rolling["Page"]) then
            GameTooltip:AddLine("Page: "..RollingCurrentPage.."/"..table.getn(Rolling["Page"]))
        else
            GameTooltip:AddLine("Page: "..RollingCurrentPage.."/"..table.getn(Rolling["Page"]).."\n"..Rolling["Page"][RollingCurrentPage+1]["Item"].."\nFrom: "..Rolling["Page"][RollingCurrentPage+1]["from"])
        end
        if RollingStart == RollingCurrentPage then
            RollingFrame.ennd:Show()
            RollingFrame.reroll:Show()
            RollingFrame.cancel:Show()
        else
            RollingFrame.ennd:Hide()
            RollingFrame.reroll:Hide()
            RollingFrame.cancel:Hide()
        end
        refreshsite(RollingCurrentPage)
        GameTooltip:Show()
    end
end)

RollingFrame.icon.left = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.icon.left:SetPoint("Right", RollingFrame, "TOP", 140-32, -40)
RollingFrame.icon.left:SetSize(32, 32)
RollingFrame.icon.left.overlay = RollingFrame.icon.left:CreateTexture(nil, "OVERLAY")
RollingFrame.icon.left.overlay:SetPoint("Right", RollingFrame, "TOP", 140-32, -40)
RollingFrame.icon.left.overlay:SetSize(32, 32)
RollingFrame.icon.left.overlay:SetTexture("interface/addons/Rolling/img/Left.blp")
RollingFrame.icon.left:RegisterForClicks("AnyUp")
RollingFrame.icon.left:SetScript("OnEnter", function(self)
    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
    GameTooltip:ClearLines()
    if RollingCurrentPage-1 <  1 then
        GameTooltip:AddLine("Page: "..RollingCurrentPage.."/"..table.getn(Rolling["Page"]))
    else
        GameTooltip:AddLine("Page: "..RollingCurrentPage.."/"..table.getn(Rolling["Page"]).."\n"..Rolling["Page"][RollingCurrentPage-1]["Item"].."\nFrom: "..Rolling["Page"][RollingCurrentPage-1]["from"])
    end
    GameTooltip:Show()
end)
RollingFrame.icon.left:SetScript("OnLeave", function()
    GameTooltip:Hide()
end)
RollingFrame.icon.left:SetScript("OnMouseDown", function(self)
    if RollingCurrentPage > 0 then
        RollingCurrentPage = RollingCurrentPage - 1
        GameTooltip:ClearLines()
        if RollingCurrentPage-1 <  0 then
            GameTooltip:AddLine("Page: "..RollingCurrentPage.."/"..table.getn(Rolling["Page"]))
        else
            GameTooltip:AddLine("Page: "..RollingCurrentPage.."/"..table.getn(Rolling["Page"]).."\n"..Rolling["Page"][RollingCurrentPage-1]["Item"].."\nFrom: "..Rolling["Page"][RollingCurrentPage-1]["from"])
        end
        if RollingStart == RollingCurrentPage then
            RollingFrame.ennd:Show()
            RollingFrame.reroll:Show()
            RollingFrame.cancel:Show()
        else
            RollingFrame.ennd:Hide()
            RollingFrame.reroll:Hide()
            RollingFrame.cancel:Hide()
        end
        refreshsite(RollingCurrentPage)
        GameTooltip:Show()
    end
end)

RollingFrame.icon.cross = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.icon.cross:SetPoint("Right", RollingFrame, "TOP", 140, -72)
RollingFrame.icon.cross:SetSize(32, 32)
RollingFrame.icon.cross.overlay = RollingFrame.icon.cross:CreateTexture(nil, "OVERLAY")
RollingFrame.icon.cross.overlay:SetPoint("Right", RollingFrame, "TOP", 140, -72)
RollingFrame.icon.cross.overlay:SetSize(32, 32)
RollingFrame.icon.cross.overlay:SetTexture("interface/addons/Rolling/img/cross.blp")
RollingFrame.icon.cross:RegisterForClicks("AnyUp")
RollingFrame.icon.cross:SetScript("OnEnter", function(self)
    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
    GameTooltip:ClearLines()
    GameTooltip:AddLine("Are you sure you want remove this?\nThis can't be redo!")
    GameTooltip:Show()
end)
RollingFrame.icon.cross:SetScript("OnLeave", function()
    GameTooltip:Hide()
end)


RollingFrame.start = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.start:SetPoint("Right", RollingFrame, "TOP", 130, -200)
RollingFrame.start:SetSize(260, 20)
RollingFrame.start:SetText("Start rolling")
RollingFrame.start:RegisterForClicks("AnyUp")
RollingFrame.start:SetScript("OnMouseDown", function()
    startroll(RollingCurrentPage)
end)
RollingFrame.start:Hide()

RollingFrame.ennd = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.ennd:SetPoint("Right", RollingFrame, "TOP", -50, -200)
RollingFrame.ennd:SetSize(80, 20)
RollingFrame.ennd:SetText("End")
RollingFrame.ennd:RegisterForClicks("AnyUp")
RollingFrame.ennd:SetScript("OnMouseDown", function()
    if RollingStart == false then
        print("|cff00ccff[Rolling] |cFFFF0000You didn't start a roll.")
    else
        local PlacingName = {}
        local PlacingRoll = {}
        if Rolling["Page"][RollingStart]["Player"] then
            looptimer = 0
            for i, v in spairs(Rolling["Page"][RollingStart]["Player"], function(t,a,b) return t[b] < t[a] end) do
                looptimer = looptimer + 1
                PlacingName[looptimer] = i
                PlacingRoll[looptimer] = v
            end
            local text = RollingI.WinChat:gsub("%%i", Rolling["Page"][RollingStart]["Item"])
            local text = text:gsub("%%p", PlacingName[1])
            local text = text:gsub("%%n", PlacingRoll[1])
            SendChatMessage(text.." Addons by 'Rolling Manager'", group)
            local namewinner = PlacingName[1].."-"..RollingPlayers[PlacingName[1]]["Realm"]
            SendChatMessage("You won, please trade with "..Rolling["Page"][RollingStart]["from"], "WHISPER", "Common", namewinner)
            SendChatMessage("Player "..PlacingName[1].." won, please trade with them!", "WHISPER", "Common", Rolling["Page"][RollingStart]["from"])
            resetsite()
        else
            resetsite()
            RollingFrame.title:SetText("Rolling Manager")
            print("|cff00ccff[Rolling] |cFFFF0000No one wanted it.")
        end
    end
end)

RollingFrame.ennd:Hide()


RollingFrame.cancel = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.cancel:SetPoint("LEFT", RollingFrame, "TOP", 50, -200)
RollingFrame.cancel:SetSize(80, 20)
RollingFrame.cancel:SetText("Cancel")
RollingFrame.cancel:RegisterForClicks("AnyUp")
RollingFrame.cancel:SetScript("OnMouseDown", function()
    if RollingStart == false then
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    else
        if RollingI.CancelMessage then
            SendChatMessage(RollingI.Cancel .." Addons by 'Rolling Manager'", group)
        end
        RollingStart = false
        resetsite()
    end
end)
RollingFrame.cancel:Hide()

RollingFrame.reroll = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.reroll:SetPoint("CENTER", RollingFrame, "TOP", 0, -200)
RollingFrame.reroll:SetSize(90, 20)
RollingFrame.reroll:SetText("Re-Roll")
RollingFrame.reroll:RegisterForClicks("AnyUp")
RollingFrame.reroll:SetScript("OnMouseDown", function()
    if not RollingStart == false then
        local text = RollingI.ReRolling:gsub("%%i", Rolling["Page"][RollingStart]["Item"])
        SendChatMessage(text.." Addons by 'Rolling Manager'", group)
        Rolling["Page"][RollingStart]["Player"] = {}
        refreshsite(RollingStart)
        resetsite()
    end
end)
RollingFrame.reroll:Hide()

RollingFrame.finishend = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.finishend:SetPoint("Right", RollingFrame, "TOP", 130, -200)
RollingFrame.finishend:SetSize(260, 20)
RollingFrame.finishend:SetText("Close / Finish")
RollingFrame.finishend:RegisterForClicks("AnyUp")
RollingFrame.finishend:Hide()

RollingFrame.title = RollingFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
RollingFrame.title:SetPoint("LEFT", RollingFrame.TitleBg, "LEFT", 5, 0)
RollingFrame.title:SetText("Rolling Manager")

RollingFrame.timer = RollingFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
RollingFrame.timer:SetPoint("LEFT", RollingFrame.TitleBg, "LEFT", 150, 0)

RollingFrame.recommend = RollingFrame:CreateFontString(nil, "ARTWORK")
RollingFrame.recommend:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
RollingFrame.recommend:SetPoint("TOPLEFT", 10, -30)
RollingFrame.recommend:SetJustifyH("LEFT")

RollingFrame.recommended = RollingFrame:CreateFontString(nil, "ARTWORK")
RollingFrame.recommended:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
RollingFrame.recommended:SetPoint("TOPLEFT", 10, -50)
RollingFrame.recommended:SetJustifyH("LEFT")

RollingFrame.text = RollingFrame:CreateFontString(nil, "ARTWORK")
RollingFrame.text:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
RollingFrame.text:SetPoint("TOPLEFT", 10, -80)
RollingFrame.text:SetJustifyH("LEFT")

RollingFrame.txt = {}
RollingFrame.win = {}

RollingFrame.win[1] = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.win[1]:SetPoint("Right", RollingFrame, "TOP", 140, -94)
RollingFrame.win[1]:SetSize(60, 20)
RollingFrame.win[1]:SetText("Winner")
RollingFrame.win[1]:RegisterForClicks("AnyUp")
RollingFrame.win[1]:SetScript("OnMouseDown", function(self)
    if RollingStart == false then
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    else
        local PlacingName = {}
        local PlacingRoll = {}
        if Rolling["Page"][RollingStart]["Player"] then
            looptimer = 0
            for i, v in spairs(Rolling["Page"][RollingStart]["Player"], function(t,a,b) return t[b] < t[a] end) do
                looptimer = looptimer + 1
                PlacingName[looptimer] = i
                PlacingRoll[looptimer] = v
            end
            local text = RollingI.WinChat:gsub("%%i", Rolling["Page"][RollingStart]["Item"])
            local text = text:gsub("%%p", PlacingName[1])
            local text = text:gsub("%%n", PlacingRoll[1])
            SendChatMessage(text.." Addons by 'Rolling Manager'", group)
            local namewinner = PlacingName[1].."-"..RollingPlayers[PlacingName[1]]["Realm"]
            SendChatMessage("You won, please trade with "..Rolling["Page"][RollingStart]["from"], "WHISPER", "Common", namewinner)
            SendChatMessage("Player "..namewinner.." won, please trade with them!", "WHISPER", "Common", Rolling["Page"][RollingStart]["from"])
            resetsite()
        else
            resetsite()
            print("|cff00ccff[Rolling] |cFFFF0000No one wanted it.")
        end
    end
end)

RollingFrame.win[2] = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.win[2]:SetPoint("Right", RollingFrame, "TOP", 140, -130)
RollingFrame.win[2]:SetSize(60, 20)
RollingFrame.win[2]:SetText("Winner")
RollingFrame.win[2]:RegisterForClicks("AnyUp")
RollingFrame.win[2]:SetScript("OnMouseDown", function()
    if RollingStart == false then
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    else
        local PlacingName = {}
        local PlacingRoll = {}
        if Rolling["Page"][RollingStart]["Player"] then
            looptimer = 0
            for i, v in spairs(Rolling["Page"][RollingStart]["Player"], function(t,a,b) return t[b] < t[a] end) do
                looptimer = looptimer + 1
                PlacingName[looptimer] = i
                PlacingRoll[looptimer] = v
            end
            local text = RollingI.PickWinner:gsub("%%i", Rolling["Page"][RollingStart]["Item"])
            local text = text:gsub("%%p", PlacingName[2])
            local text = text:gsub("%%n", PlacingRoll[2])
            SendChatMessage(text.." Addons by 'Rolling Manager'", group)
            local namewinner = PlacingName[2].."-"..RollingPlayers[PlacingName[2]]["Realm"]
            SendChatMessage("You won, please trade with "..Rolling["Page"][RollingStart]["from"], "WHISPER", "Common", namewinner)
            SendChatMessage("Player "..namewinner.." won, please trade with him!", "WHISPER", "Common", Rolling["Page"][RollingStart]["from"])
            resetsite()
        else
            resetsite()
            print("|cff00ccff[Rolling] |cFFFF0000No one wanted it.")
        end
    end
end)

RollingFrame.win[3] = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.win[3]:SetPoint("Right", RollingFrame, "TOP", 140, -165)
RollingFrame.win[3]:SetSize(60, 20)
RollingFrame.win[3]:SetText("Winner")
RollingFrame.win[3]:RegisterForClicks("AnyUp")
RollingFrame.win[3]:SetScript("OnMouseDown", function()
    if RollingStart == false then
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    else
        local PlacingName = {}
        local PlacingRoll = {}
        if Rolling["Page"][RollingStart]["Player"] then
            looptimer = 0
            for i, v in spairs(Rolling["Page"][RollingStart]["Player"], function(t,a,b) return t[b] < t[a] end) do
                looptimer = looptimer + 1
                PlacingName[looptimer] = i
                PlacingRoll[looptimer] = v
            end
            local text = RollingI.PickWinner:gsub("%%i", Rolling["Page"][RollingStart]["Item"])
            local text = text:gsub("%%p", PlacingName[3])
            local text = text:gsub("%%n", PlacingRoll[3])
            SendChatMessage(text.." Addons by 'Rolling Manager'", group)
            local namewinner = PlacingName[3].."-"..RollingPlayers[PlacingName[3]]["Realm"]
            SendChatMessage("You won, please trade with "..Rolling["Page"][RollingStart]["from"], "WHISPER", "Common", namewinner)
            SendChatMessage("Player "..namewinner.." won, please trade with him!", "WHISPER", "Common", Rolling["Page"][RollingStart]["from"])
            resetsite()
        else
            resetsite()
            print("|cff00ccff[Rolling] |cFFFF0000No one wanted it.")
        end
    end
end)
RollingFrame.win[1]:Hide()
RollingFrame.win[2]:Hide()
RollingFrame.win[3]:Hide()

RollingFrame.txt[1] = RollingFrame:CreateFontString(nil, "ARTWORK")
RollingFrame.txt[1]:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
RollingFrame.txt[1]:SetPoint("TOPLEFT", 10, -104)
RollingFrame.txt[1]:SetJustifyH("LEFT")

RollingFrame.txt[2] = RollingFrame:CreateFontString(nil, "ARTWORK")
RollingFrame.txt[2]:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
RollingFrame.txt[2]:SetPoint("TOPLEFT", 10, -139)
RollingFrame.txt[2]:SetJustifyH("LEFT")

RollingFrame.txt[3] = RollingFrame:CreateFontString(nil, "ARTWORK")
RollingFrame.txt[3]:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
RollingFrame.txt[3]:SetPoint("TOPLEFT", 10, -174)
RollingFrame.txt[3]:SetJustifyH("LEFT")

RollingFrame.txt4 = RollingFrame:CreateFontString(nil, "ARTWORK")
RollingFrame.txt4:SetFont("Fonts\\ARIALN.ttf", 16, "OUTLINE")
RollingFrame.txt4:SetPoint("TOPLEFT", 50, -38)
RollingFrame.txt4:SetJustifyH("LEFT")

RollingFrame.icon = CreateFrame("Button", nil, RollingFrame, "GameMenuButtonTemplate")
RollingFrame.icon:SetPoint("Right", RollingFrame, "TOP", -100, -55)
RollingFrame.icon:SetSize(40, 40)
RollingFrame.icon.overlay = RollingFrame.icon:CreateTexture(nil, "OVERLAY")
RollingFrame.icon.overlay:SetPoint("Right", RollingFrame, "TOP", -100, -55)
RollingFrame.icon.overlay:SetSize(40, 40)
RollingFrame.icon.overlay:SetTexture(GetItemIcon(6948))
RollingFrame.icon:SetScript("OnEnter", function(self)
    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
    GameTooltip:ClearLines()
    if Rolling["Page"][Page]["Item"] then
        local _, id = GetItemInfo(tostring(Rolling["Page"][Page]["Item"]))
        GameTooltip:SetHyperlink(id)
    else
        local _, id = GetItemInfo("Ruhestein")
        GameTooltip:SetHyperlink(id)
    end
    GameTooltip:Show()
end)
RollingFrame.icon:SetScript("OnLeave", function() GameTooltip:Hide() end)
RollingFrame.icon:Show()

RollingFrame:Hide()